
/* cmd.h	- header file for commands
   distributed as part of _ s u l a _


    Author: Tano Fotang, 1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License , or
    (at your option) any later version.
    see the file COPYING for mor einfo.

*/

#ifndef _sula_cmds_h
#define _sula_cmds_h

#include "scheme.h"


char	cmdchar;	/* command char , default '/' */
char	*ml_nl;		/* to place before newlines in multiline msges. defaullt:\t*/

/* command types*/
#define  CMD_IN		( 1<<00 ) /* built-in cmd */
#define  CMD_SCM	( 1<<01 ) /* Scheme defined cmd */
#define  CMD_FD		( 1<<02 ) /* command defined by external script */

#define  CMD_NORMAL	( 1<<10 )
#define  CMD_CTCP	( 1<<11 )
#define	MAXCMDLEN	30 	/* max sula cmd length; doesent seem 2b used anywhere..*/


typedef struct TCmd{
	char	*name;
	char	*help;
	int	type;		
	union	{
		void	(*in)(void *);	/*IN_NORMAL */
		int	sp;
	#ifdef _GUILE
		int	scm; 	/* index to scm_func */
	#endif
	} cmd;
	int	bf; 
	struct TCmd *left;
	struct TCmd *right;
} Cmd;

typedef Cmd	*pCmd;
Cmd		*cmdTree;
int		no_of_cmds;
Cmd		*ctcp_cmdTree;
int		no_of_ctcp_cmds;
typedef struct TCmdStruct{
	Winstruct *win;
	char	*args;		/* cmd arguments*/
}CmdStruct;
#define SERV_CMD	(1<<0)
#define CLI_CMD		(1<<1)
typedef struct TCmdOnCon{
	int	type;	/* SERV_CMD:sendto_server, CLI_CMD:process cmd*/
	char	*cmd;
	char	*server;
	u_short	port;
	struct TCmdOnCon *next;
} CmdOnCon;	/* do cmd upon connecting */
CmdOnCon	*cmdonconStart, *cmdonconEnd;

extern Cmd *_find_cmd(char *name, int type, int how);
#define find_ctcp_cmd(name, fullname)  _find_cmd((name),(CMD_CTCP),(fullname))
#define find_cmd(name, fullname)  _find_cmd((name),(CMD_NORMAL),(fullname))
extern int _remove_cmd(char *name,int type);
#define remove_cmd(name) _remove_cmd((name),(CMD_NORMAL))
#define remove_ctcp_cmd(name) _remove_cmd((name),(CMD_CTCP))

extern void add_cmdoncon(int type, char *cmd, char *serv, u_short port);

extern int _insert_cmd(pCmd *pp, Cmd *c, int *count);
#define insert_cmd(c) _insert_cmd(&cmdTree,(c),&no_of_cmds)
#define insert_ctcp_cmd(c) _insert_cmd(&ctcp_cmdTree,(c),&no_of_ctcp_cmds)

extern void send_blocktxt(int, const char *,int);
extern int new_process_cmd (const char *, int);
#define process_cmd(str, win) \
	new_process_cmd((str),\
	(win)!=NULL? (win)-winstruct : -1)
extern int parse_scheme(const char *, int);
extern int parse_input(int, const char *, int);
/*
extern void unquote_str(char **);
extern void quote_str(char **); */
extern int load_ctcp_cmds(void);

//void print_cmd_tree(Cmd *p , int pos);
//void list_cmds(Cmd *p);
extern int show_std_help(const char *,const char *, FD_chanwin *);

extern  int on_channel(const Server *, const char *); 
extern void jjoin(Winstruct *win);
void ClearWinChanList(Winstruct *win);

extern void set(int argc, char **argv, Winstruct *win);
extern void log_set(int,const void *);



#endif
