


#ifndef _sula_hooks_h
#define _sula_hooks_h


#define CTCP_more 1
typedef enum msgnr {  /*keep sorted*/

/* Received */
ACTION=0, 
CTCP_ALL,
#if CTCP_more
// please us CTCP_ALL
// example: 
// CTCP_PING => CTCP_ALL "* :?PING *"

CTCP_CLIENTINFO,
CTCP_FINGER,
CTCP_HELP,
CTCP_PING,
CTCP_REPLY,
CTCP_SED,
CTCP_SOURCE,
CTCP_TIME,
CTCP_UNKNOWN,
CTCP_USERINFO,
CTCP_VERSION,
#else
CTCP_UNKNOWN,
#endif
DCC_CHATMSG,
DCC_CHAT_DONE,	/* after closing connection */
DCC_CHAT_LOST,	/* p->nick, p->read, p->rem_host, p->email*/
DCC_CHAT_REQUEST,	/* received a req to chat*/
DCC_CHAT_START,	/* upon successfully conencting */
DCC_GET_DONE,	/* finished getting file. p->host, p->email, p->filename, p->size, p->read*/
DCC_GET_REQUEST, /* before sending out a dcc file request */
DCC_GET_START,	/* established connection to get a file*/
DCC_SEND_DONE,	/* finished sending file. p->host, p->filename, p->size, p->read*/
DCC_SEND_REQUEST,	/* someone sendin us a file */
DCC_SEND_START,	/* established connection to send . "w nick remote_addr emailadrr" */
ERROR,		/* server reports error */
EXIT,		/* just before client shutdown*/
INVITE ,
JOIN ,
JUNK ,
KICK ,
MODE ,
NC,		/* arg:index lineRead */
NC_LOST,	/* args:index name */
NICK, 
NOTE ,
PART ,
PING, /* received a server ping */
PONG, /* received a server pong */
PRIV_FLOOD,
PRIVMSG,
PRIVNOTICE,
PUB_FLOOD,
PUBMSG,
PUBNOTICE ,
QUIT,		/* someone signed off */
RAW_IRC,
/* before sending out */
SEND_ACTION,
SEND_CHATMSG,
SEND_DCC_CHAT,
SEND_ENCRYPTED_PRIVMSG,
SEND_ENCRYPTED_PRIVNOTICE,
SEND_ENCRYPTED_PUBNOTICE, 
SEND_ENCRYPTED_PUBVMSG,
SEND_PRIVMSG ,
SEND_PRIVNOTICE,
SEND_PUBMSG,
SEND_PUBNOTICE, 

//SERVER,		/* use numeric 001 */
SERVER_LOST,	/* server closed connection */
SIGNOFF,	/* when user wishes to signoff irc, e.g. just after Quit command is typed */
// args: servername,port nick
SILENCE,
TOPIC,
WALLOPS,
INVALID
} MsgNr;


#define HK_IN		(1<<0)
#define HK_FD		(1<<1)
#define HK_SCM		(1<<2)

#define HK_NOISY	(1<<3)	/* only for CMD_IN;curently meaningless*/
#define HK_SUSPENDED	(1<<4) 	/* valid for both; hook suspended */
#define HK_EXCLUSIVE	(1<<5)	/* valid only for CMD_FD: send matches to me alone */
#define HK_ISACTIVE	(1<<6)  /* is set while hook is being processed so u dont remove
a hook from within it */
#define HK_PREEMPTIVE	(1<<7)	/* whether message processing continues or not is to
to be determined by the return value of the hook*/
#define HK_RESET_MODE	(~0 & ~(HK_NOISY | HK_SUSPENDED | HK_EXCLUSIVE))
#define HK_RESET	(0)/*~(HK_NOISY | HK_SUSPENDED | HK_EXCLUSIVE))*/

typedef struct TOn{
	int	id;		/* make sense only for CMD_FD */
	char	*pattern;	/* pattern (wildcards) */
	int	ser_number;	/* for CMD_IN no duplicates allowed */
	int	flag;		/* type|flag; flag!=0 :for CMD_FD: send to me alone and suspended.
				flag=  SILENT|NOISY |IS_ACTIVE|PREEMPTIVE etc */
	
	union	{
		int	sp;
		char	*cmd;/* sula cmd;expand cmd and process */
		#ifdef _GUILE
		int     scm; /* Scheme variable name. (define XX<scm> func) */
		#endif
	} cmd;
	struct TOn *next;
} On;

typedef struct TWant{
	MsgNr	type;		/*  */
	On	*start;
	On	*end;
}Want;

/* this should the number of msg types, hooks.c*/
extern int MAX_ON;
Want *want; /*[MAX_ON];*/

typedef struct TNumHook{
	int	numeric;
	On	*start;
	On	*end;
	int	bf;
	struct TNumHook	*left;
	struct TNumHook	*right;
} NumHook;
typedef NumHook	*pNumHook;
NumHook	*numTree;

extern NumHook *find_numhook(int);

extern  MsgNr get_type(const char *);/*to be removed*/
extern void *lookup_type(const char *, int *);
extern int do_internal_hook(On *, const char *msg, int,char);
extern int check_msg_hook(MsgNr,int, const char *, ...);
extern int check_numeric(int, Winstruct*, const char *);
extern void event_setup(void);
extern void delete_hook(char *,char preempt);
#define del_hook(s) delete_hook((s),0) /* del_hook(#pubmsg 100 pattern) */
extern void hook_list (FL_OBJECT *b,int script,int do_list);
#define list_hooks(n) hook_list(NULL,1,(n))
extern void add_hook2(MsgNr,On *,void *blabla);
extern void add_numhook2(int , On *, void *blabla);
#define add_numhook(n,on)    add_numhook2((n),(on),0)
#define add_hook(n,on)	     add_hook2((n),(on),0)

#endif
