#include <forms.h>
#include <errno.h>
#include <sys/param.h>
#include "aux.h"
#include "sula.h"
#include "chanwin.h"
#include "global.h"
#include "cmd.h"
#include "help.h"

void whatis(int argc, char **argv, Winstruct *win){

	if(argc==1){ /* /whatis	*/
		fl_addto_browser(win->chanwin->brow2, PROMPT"whatis what?");
		#if DEBUG > 9
		print_cmd_tree(cmdTree , 8);
		#endif
		return ;
	}else
	{
		Cmd *p;
		char *buf=NULL;
		p=find_cmd( argv[1],0);
		if(!p) p=find_ctcp_cmd( argv[1],0);
		if(!p){
			buf=(char *)malloc(sizeof(char)*(strlen(argv[1])+30+strlen(PROMPT)));
			sprintf(buf, PROMPT"%s:  nothing appropriate", argv[1]);
			fl_addto_browser(win->chanwin->brow2, buf);
			free(buf);
			return ;
		}
		if(p->help){
			 buf=(char *)malloc(sizeof(char)*(strlen(p->name)+
			 strlen(p->help)+5+strlen(PROMPT)));
			 sprintf(buf, PROMPT"%s: %s", p->name,p->help);
			 fl_addto_browser(win->chanwin->brow2,buf);
		}
		else{
		 	buf=(char *)malloc(sizeof(char)*(strlen(argv[1])+40+strlen(PROMPT)));
			sprintf(buf, PROMPT"%s:  no entry found", argv[1]);
			fl_addto_browser(win->chanwin->brow2, buf);
		}
		free(buf);
	}
	return;
}

void apropos2(int argc, char **argv, Winstruct *win){
       static void show_apropos(Cmd *p,const char *cmd, FL_OBJECT *brow,int *);

	if(argc==1){ /* /apropos	*/
		fl_addto_browser(win->chanwin->brow2, PROMPT"apropos what?");
	}
	else
	{
		int i;
		int j=i=0;
		lowercase2(argv[1]);
		show_apropos(cmdTree, argv[1],win->chanwin->browser, &i);
		show_apropos(ctcp_cmdTree, argv[1],win->chanwin->browser, &j);
		if(i==0 && j==0){
			char *buf=(char *)malloc(sizeof(char)*(strlen(argv[1])+32+strlen(PROMPT)));
			sprintf(buf, PROMPT"apropos %s: nothing appropriate", argv[1]);
			fl_addto_browser(win->chanwin->brow2, buf);
			free(buf) ;
		}
	}
}

static void show_apropos(Cmd *p, char *str, FL_OBJECT *brow, int *i){
	static int j=0;

	if(p){
		char buf[MAXLINE];
		show_apropos(p->left, str, brow,i);
		// todo: freee freee free
		if(strstr(lowercase(p->name), str) || 
		(p->help && strstr(lowercase(p->help), str))) {
			sprintf(buf, "@f%s%-24.20s- %s%s",  p->type&CMD_IN?" ":"*", 
		 	p->name,  p->type&CMD_CTCP?"(CTCP) ":"", p->help?p->help:""
		   );
			fl_addto_browser(brow, buf);
			(*i)++; 
		}
		if(++j==no_of_cmds)
			j=0;
		show_apropos(p->right, str, brow,i);
	}
}
int show_std_help(const char *s1, const char *s2, FD_chanwin *chanwin){
/* leave here so as not to have to include help.h everywhere */
	char *hfname;
	char *hdir=sula_lib;
	
	size_t ll;
	if(s1==0 || *s1==0) return -1;
	ll=strlen(hdir);
	#if 0
	if(*(hdir+ll-1)=='/')
		*(hdir+ --ll)='\0';
	#endif
	if(ll==0) ll=1;
	
	if(s2==0 || *s2==0){
		hfname=(char *)alloca(sizeof(char)*(ll+	strlen(s1)+ 16));
		if(!hfname) goto failed;
		sprintf(hfname,"%s/help/%s.hlp", *hdir?hdir:".",s1);
	}
	else {
		hfname=(char *)alloca(sizeof(char)*(ll+ strlen(s1)+ strlen(s2)+16));
		if(!hfname) goto failed;
		sprintf(hfname,"%s/help/%s/%s.hlp", *hdir?hdir:".", s1, s2);
	}
	if( access( hfname, R_OK)<0) goto failed;
	else{
		
		#define BUFF 1024
		FL_OBJECT *b;
		FILE *fp=fopen(hfname,"r");
		char buf[BUFF+2];
		if(fp==NULL) goto failed;
		b=chanwin? chanwin->browser: main_form->browser;
		if(chanwin) fl_freeze_form(chanwin->chanwin);
		else fl_freeze_form(main_form->main_form);
		while(fgets(buf, BUFF, fp)){
			buf[strlen(buf)-1]=' ';	/* kludge to include empty lines */
			fl_addto_browser(b, buf);
		}
		fl_addto_browser(b,"\n");
		if(chanwin) fl_unfreeze_form(chanwin->chanwin);
		else fl_unfreeze_form(main_form->main_form);
		fclose(fp);
		/*fl_load_browser(chanwin->browser,hfname); this clears browser!*/
		
	}
	return 0;
	failed:
		{
		
		char *buf;
		char *errstr=strerror(errno);
		int err=errno;
		if (gflags & BEEP_ERR) fl_ringbell(0);
		buf=alloca(sizeof(char)*(strlen(s1)+(s2?strlen(s2):0)+
		strlen(errstr)+ strlen(PROMPT)+16));
	 	sprintf(buf,PROMPT"help for %s %s: %s", s1, s2?s2:"",errstr);
	 	if(chanwin) fl_addto_browser(chanwin->brow2, buf);
		else fl_addto_browser(main_form->browser, buf);
		return err;
		}

}

void help(int argc, char **argv, Winstruct *win){
/* show help on a cmd*/
       static void show_cmds_in_columns(Cmd *p, FL_OBJECT *brow);

	if(argc==1){
		fl_addto_browser(win->chanwin->browser,"@-");
		fl_addto_browser(win->chanwin->browser,"@b@i\t\tHelp Topics");
	       	show_cmds_in_columns(cmdTree,win->chanwin->browser);
		fl_addto_browser(win->chanwin->browser,"@b@i\tCTCP commands");
		show_cmds_in_columns(ctcp_cmdTree,win->chanwin->browser);
	}
	else
	{
		Cmd *cmd;
		int to=win?win-winstruct:-1;
		cmd=find_cmd(argv[1],0);
		if(!cmd){
		  say2(to,-1,PROMPT"%s: Unknown command", argv[1]);return;
		 }
		if(cmd->type&CMD_IN){
		      uppercase2(argv[1]);
		      if(argv[2]) uppercase2(argv[2]);
		      show_std_help(argv[1],argv[2],win->chanwin);
		}
		else{
		     char buf[MAXLINE], *buf2=NULL;
		     int i=1;
		    buf[0]='\0';
		    while(++i<argc)
			strcat(buf, argv[i]);
		    buf2=alloca(sizeof(char)*(strlen(cmd->name)+10+strlen(buf))) ;
		   sprintf(buf2,"%s -help %s", cmd->name, buf[0]?buf:"");
		   i=new_process_cmd(buf2, to);
		   if(i)
		      say2(to,-1,PROMPT"%s: Unknown command", argv[1]);
		}
	}
}

static void show_cmds_in_columns(Cmd *p, FL_OBJECT *brow){
	static char buf[100];
	char s[50];
	static int i=0, total=0;
	if(i==0) buf[0]='\0';
	if(p){
		show_cmds_in_columns(p->left, brow);
		if(i==0) strcat(buf, "@f");
		sprintf(s, "%-1.1s%-15.13s", 
		#ifdef _GUILE
		p->type&(CMD_IN|CMD_SCM)
		#else
		p->type&CMD_IN
		#endif
		?" ":"*", p->name);
		strcat(buf, s);
		i++;  total= ++total%no_of_cmds;
		if(i==4 || total==0){
			i=0;
			fl_addto_browser(brow, buf);
			buf[0]='\0';
		}
		show_cmds_in_columns(p->right, brow);
	}
}
