/*
 * hooks.c 
 * distributed as part of _ s u l a _
 * 
 * Author: Tano Fotang, 1998
 * 
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free 
 * Software Foundation; either version 2 of the License , or (at your option) 
 * any later version.
 * see the file COPYING for further information.

 */




#include <forms.h>
#include <time.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/wait.h>
#include <fnmatch.h>
#include <ctype.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdarg.h>
#include "aux.h"
#include "sula.h"
#include "script_gui.h"
#include "chanwin.h"
#include "global.h"
#include "script.h"
#include "dcc.h"
#include "setting.h"
#include "scheme.h"
#include "hooks.h"
#include "cmd.h"
int MAX_ON;
extern FD_scriptcontrol *script_form;
/*extern Winstruct *Win;*/
static int event_id = 0;
void *
lookup_type (const char *cmdname, int *is_numeric)
{
/* on return, flag==0 if type is  not numeric; */
  static int num;
  char *s;
  *is_numeric = 0;		/* is not numeric */
  num = (int) strtol (cmdname, &s, 0);
  if (*s)
    {
      static MsgNr type = INVALID;
      type = get_type (cmdname);
      return ((void *) &type);
    }
  else
    {
      *is_numeric = 1;
      if (num < 1)
	return NULL;
      else
	return ((void *) &num);
    }
}
typedef struct TMsgType
{
  MsgNr nr;
  char *name;
}
MsgType;
static MsgType msg_type[] =
{
/* keep sorted by both nr (see get_type_by_num) and name */

  {ACTION, "ACTION"},
  {CTCP_ALL, "CTCP_ALL"},
  
  #if CTCP_more
  // use CTCP_ALL
  // example: 
  // CTCP_PING => CTCP_ALL "* :?PING *"
  // (string-set! s 0 #\001)(string-set! s (- (string-length s) 1) #\001)
  {CTCP_CLIENTINFO, "CTCP_CLIENTINFO"},
  {CTCP_FINGER, "CTCP_FINGER"},
  {CTCP_HELP, "CTCP_HELP"},
  {CTCP_PING, "CTCP_PING"},
  {CTCP_REPLY, "CTCP_REPLY"},
  {CTCP_SED, "CTCP_SED"},
  {CTCP_SOURCE,"CTCP_SOURCE"},
  {CTCP_TIME, "CTCP_TIME"},
  {CTCP_UNKNOWN, "CTCP_UNKNOWN"},
  {CTCP_USERINFO, "CTCP_USERINFO"},
  {CTCP_VERSION, "CTCP_VERSION"},
  #else
  {CTCP_UNKNOWN, "CTCP_UNKNOWN"},
  #endif
  {DCC_CHATMSG, "DCC_CHATMSG"},
  {DCC_CHAT_DONE,"DCC_CHAT_DONE"},/* chat connection closed */
  {DCC_CHAT_LOST,"DCC_CHAT_LOST"},
  {DCC_CHAT_REQUEST, "DCC_CHAT_REQUEST"},
  {DCC_CHAT_START,"DCC_CHAT_START"},/* on successfully conencting */
  {DCC_GET_DONE, "DCC_GET_DONE"},
  {DCC_GET_REQUEST,"DCC_GET_REQUEST"}, /* before sending out a dcc file request */
  {DCC_GET_START,"DCC_GET_START"},
  {DCC_SEND_DONE, "DCC_SEND_DONE"},
  {DCC_SEND_REQUEST, "DCC_SEND_REQUEST"},
  {DCC_SEND_START,"DCC_SEND_START"},
  {ERROR, "ERROR"},
  {EXIT, "EXIT"},
  {INVITE, "INVITE"},
  {JOIN, "JOIN"},
  {JUNK, "JUNK"},
  {KICK, "KICK"},
  {MODE, "MODE"},
  {NC,"NC"},
  {NC_LOST,"NC_LOST"},
  {NICK, "NICK"},
  {NOTE, "NOTE"},
  {PART, "PART"},
  {PING, "PING"},
  {PONG, "PONG"},
  {PRIV_FLOOD,"PRIV_FLOOD"},
  {PRIVMSG, "PRIVMSG"},
  {PRIVNOTICE, "PRIVNOTICE"},
  {PUB_FLOOD,"PUB_FLOOD"},
  {PUBMSG, "PUBMSG"},
  {PUBNOTICE, "PUBNOTICE"},
  {QUIT, "QUIT"},
  {RAW_IRC,"RAW_IRC"},

  {SEND_ACTION,"SEND_ACTION"},
  {SEND_CHATMSG,"SEND_CHATMSG"},
  {SEND_DCC_CHAT,"SEND_DCC_CHAT,"}, 
  {SEND_ENCRYPTED_PRIVMSG,"SEND_ENCRYPTED_PRIVMSG"},
  {SEND_ENCRYPTED_PRIVNOTICE,"SEND_ENCRYPTED_PRIVNOTICE"},
  {SEND_ENCRYPTED_PUBNOTICE,"SEND_ENCRYPTED_PUBNOTICE"},
  {SEND_ENCRYPTED_PUBVMSG,"SEND_ENCRYPTED_PUBVMSG" },
  {SEND_PRIVMSG ,"SEND_PRIVMSG"},
  {SEND_PRIVNOTICE ,"SEND_PRIVNOTICE"},
  {SEND_PUBMSG,"SEND_PUBMSG"},
  {SEND_PUBNOTICE,"SEND_PUBNOTICE"},
   
  //{SERVER,"SERVER"}, use numeric 001
  {SERVER_LOST, "SERVER_LOST"},
  {SIGNOFF,"SIGNOFF"},
  {SILENCE, "SILENCE"},
  {TOPIC, "TOPIC"},
  {WALLOPS, "WALLOPS"}
  };


extern int MAX_ON;
void event_setup (void)
{

	register i;
	MsgType *p=msg_type;
	MAX_ON=sizeof(msg_type)/sizeof(MsgType);/*sizeof(event)/sizeof(MsgNr)-1;*//* -INVALID*/

	want=(Want *)malloc(sizeof(Want)*MAX_ON);
	if (!want)
		error(-2,"malloc error");
	i=0;
	while(i<MAX_ON){
		want[i].type=p->nr;
		want[i].start=want[i].end=NULL;
		i++;p++;
	}
}

extern MsgNr 
get_type (const char *var)
{
#warning (25Nov98) Optimize this proc -mtf
  MsgType *p = msg_type;
  register int low, high, mid, cond;

  low = 0;
  high = MAX_ON-1;
  while (low <= high)
    {
      mid = (low + high) / 2;
      if ((cond = strcasecmp (var, (p + mid)->name)) < 0)
	high = mid - 1;
      else if (cond > 0)
	low = mid + 1;
      else
	return (p + mid)->nr;
    }
  return INVALID;
}
static MsgNr 
get_type_by_num (MsgNr var)
{
  MsgType *p = msg_type;
  register int low, high, mid;
  low = 0;
  high = MAX_ON-1;
  while (low <= high)
    {
      mid = (low + high) / 2;
      if (var < (p + mid)->nr)
	high = mid - 1;
      else if (var>(p + mid)->nr)
	low = mid + 1;
      else
	return mid;
    }
  return -1;
}


void 
hook_list (FL_OBJECT *b,int script,int do_list)
{
  static void list_numhooks (NumHook * h, FL_OBJECT * brow);
  int i;
  #define LLEN 512
  char *buf;
  FL_OBJECT *brow;
  if(script)
  if (!script_form)
    return;
  buf = alloca (sizeof (char) * LLEN);
  if(script){
  brow = do_list ? ((FD_event *) script_form->folder->u_vdata)->browser :
    ((FD_script *) script_form->folder->u_ldata)->browser;
  fl_clear_browser (brow);
  fl_freeze_form (script_form->scriptcontrol);
  }
  else brow=b;
  if (do_list)
    {
      /*hooks */
      On *p;

      sprintf (buf, "@N@m%-14.18s ID  %-10s Sock P %s ", "Command", "SN", "Pattern");
      fl_addto_browser (brow, buf);
      for (i=0; i<MAX_ON; i++)
	{
	  p = want[i].start;
	  while (p != want[i].end)
	    {
	      *buf = 0;
	      
	      if(snprintf (buf,LLEN, "%s%-19.17s %-4d %-12d %-6d %c  %s", (
		p->flag & HK_SUSPENDED ||  (p->flag & HK_FD  &&
		    s_pipe[p->cmd.sp].status & (SCR_SUSPENDED | SCR_STOPPED))
		       )? "@C4@z" : "",
		       msg_type[i].name,
		       p->id, p->ser_number,
		       (p->flag & HK_FD) ? p->cmd.sp : (-1),
		       (p->flag & HK_PREEMPTIVE)?'Y':'N',
		       p->pattern)==-1)
		  buf[LLEN]=0;
	      fl_addto_browser (brow, buf);
	      p = p->next;
	    }
	}
      list_numhooks (numTree, brow);
    }
  else
    {
      /* scripts */
      for (i = 0; i < sp_count; i++)
	{
	  if (s_pipe[i].fd < 0)
	    continue;
	  
	  switch(s_pipe[i].type){
	  case  CON_SCRIPT:
	  sprintf (buf, "%s%s %d %s",
		   s_pipe[i].status & SCR_SUSPENDED ? "@C4@z" :
		   (s_pipe[i].status & SCR_STOPPED ? "@i" : ""),
		   s_pipe[i].name,i,s_pipe[i].to.proc->sys_cmd);
		   break;
	case CON_SERVER:
	sprintf (buf, "%s%s %d %s",
		   s_pipe[i].status & SCR_SUSPENDED ? "@C4@z" :
		   (s_pipe[i].status & SCR_STOPPED ? "@i" : ""),
		   s_pipe[i].name,i,s_pipe[i].to.server.name);
		   break;
	case CON_DCC:
	sprintf (buf, "%s%s %d",
		   s_pipe[i].status & SCR_SUSPENDED ? "@C4@z" :
		   (s_pipe[i].status & SCR_STOPPED ? "@i" : ""),
		   s_pipe[i].to.dcc.nick,i);
		   break;
	default:
	 sprintf (buf, "%s%s %d",
		   s_pipe[i].status & SCR_SUSPENDED ? "@C4@z" :
		   (s_pipe[i].status & SCR_STOPPED ? "@i" : ""),
		   "Bug: unknown hook type",s_pipe[i].type);
		   break;
	}
	  fl_addto_browser (brow, buf);
	}
    }
  if(script)
      fl_unfreeze_form (script_form->scriptcontrol);
}

static void 
list_numhooks (NumHook * h, FL_OBJECT * brow)
{
  if (h)
    {
      On *p;
      char *buf;
      list_numhooks (h->left, brow);
      buf = malloc (sizeof (char) * 513);
      if (!buf)
	return;
      p = h->start;
      while (p != h->end)
	{
	  if(snprintf (buf,LLEN,
		   "%s%-19.3d %-4d %-12d %-6d %c  %s",
		   (p->flag & HK_SUSPENDED ||
		    (p->flag & HK_FD &&
		     s_pipe[p->cmd.sp].status & (SCR_SUSPENDED | SCR_STOPPED)
		    )
		   )? "@C4@z" : "",
		   h->numeric,
		   p->id, p->ser_number,
		   (p->flag & HK_FD) ? p->cmd.sp : (-1),
		   (p->flag & HK_PREEMPTIVE)?'Y':'N',
		   p->pattern)==-1)
	   buf[LLEN]=0;
	  fl_addto_browser (brow, buf);
	  p = p->next;
	}
      free (buf);
      list_numhooks (h->right, brow);
    }
}
static void 
clear_in_hook (On **p, On **end, int ser_nr, char *pattern,char preempt)
{
/* remove one on-hook entry from a hook list
   top of list: *p
   bottom of list: *end
 */
  
  // cant remove a hook from within itself;bad things happen
  // --> (*p)->flag&HK_ISACTIVE
  if (
  ((!preempt && !((*p)->flag&HK_PREEMPTIVE)) ||
	    (preempt && (*p)->flag&HK_PREEMPTIVE)) &&
  (*p)->flag & (HK_IN | HK_SCM) && !((*p)->flag&HK_ISACTIVE) &&
   ((*p)->ser_number == ser_nr || ser_nr < 0)
   &&
      (!pattern || !strcasecmp ((*p)->pattern, pattern)))
    {
      On *q = (*p)->next;
      free ((*p)->pattern);
      if ((*p)->flag & HK_IN)
	free ((*p)->cmd.cmd);
#ifdef _GUILE
      else if((*p)->flag & HK_SCM)
	scm_func[(*p)->cmd.scm].idx=-1;
#endif
      if (q == *end)
	*end = *p;
      else
	**p = *q;
      free (q);
    }
  else
    *p = (*p)->next;
}

static void 
remove_hook_bytype (MsgNr n, int ser_nr, char *pattern,char preempt)
{
/* remove on-hooks for a non-numeric msg type if event matches <pattern */
  On *q;
  register j;
  j=get_type_by_num(n);
  if(j<0) return;
  q = want[j].start;
  while (q != want[j].end)
        clear_in_hook (&q, &(want[j].end), ser_nr, pattern,preempt);
}

static void 
remove_numhook_bynum (int numeric, int ser_nr, char *pattern,
 NumHook * h,char preempt)
{
/* remove on-hooks for a numeric if event matches <pattern> */
  if (h)
    {
      On *p;
      remove_numhook_bynum (numeric, ser_nr, pattern, h->left,preempt);
      p = h->start;
      if(h->numeric==numeric)
        while (p != h->end)
	  clear_in_hook (&p, &h->end, ser_nr, pattern,preempt);
      remove_numhook_bynum (numeric, ser_nr, pattern, h->right,preempt);
    }
}

static void hook_replace(On *p,On *what, int not_different, void *proc)
/* replace p with what */
{
	  if (not_different)
	  /* pattern exists already; just change it */
	    {
	      free (p->pattern);
	      p->pattern = strdup (what->pattern);
	    }
	  if(p->flag & HK_IN) free (p->cmd.cmd);
#if defined _GUILE
	  if (what->flag & HK_SCM)
	    {
	      assert(gh_procedure_p(*((SCM *)proc)));
	      scm_func[p->cmd.scm].idx=-1;
	      p->cmd.scm=define_func(*((SCM *)proc));
              if(p->cmd.scm<0) error(-2,"malloc error");
	     // p->flag=(p->flag & ~(HK_IN | HK_FD)) | HK_SCM;
	    }
	  else
#endif
	  if (what->flag & HK_IN)
	    {
	      p->cmd.cmd = strdup (what->cmd.cmd);
	    }
	  p->flag |= what->flag;
}
static void insert_hook(On *q,On *what,On **end)
// insert what just before q
  {
      On *p = malloc (sizeof (On));
      if (!p)
	error(-2,"malloc error");
      if(q==*end) *end=p; else *p=*q;
      q->flag = what->flag;
      if (what->flag& HK_SCM)
#if defined _GUILE
	q->cmd.scm = what->cmd.scm
#endif
	  ;
      else if (what->flag&HK_IN)
	q->cmd.cmd = strdup (what->cmd.cmd);
      else
	q->cmd.sp = what->cmd.sp;
      q->ser_number = what->ser_number;
      q->pattern = lowercase (what->pattern);
      q->id = ++event_id;
      q->next = p;
  }
void add_hook2 (MsgNr n, On * what, void *proc)
{
/* add message hook script */
  On *p, *q;
  register i;

 #ifdef _GUILE
  assert(what->flag&(HK_IN |HK_SCM | HK_FD));
  #else
  assert(what->flag&(HK_IN | HK_FD));
  #endif
  i=get_type_by_num(n);
  assert(i>-1);
  if (want[i].start == want[i].end && want[i].start == NULL)
    {
      want[i].start = want[i].end = malloc (sizeof (On));
      if (want[i].start == NULL)
	  error(-2,"malloc error");
      want[i].start->flag = HK_RESET_MODE;
    }
  what->flag &= ~HK_ISACTIVE;
  p = want[i].start;
  while (p != want[i].end)
      if(!strcasecmp (p->pattern, what->pattern) &&
      (((p->flag & HK_PREEMPTIVE && what->flag&HK_PREEMPTIVE)
	   || (!(p->flag & HK_PREEMPTIVE) && !(what->flag&HK_PREEMPTIVE)))
	 &&
	 (((p->flag & (HK_IN | HK_SCM) && what->flag & (HK_IN | HK_SCM))
	 &&
	      ((what->flag & (HK_IN | HK_SCM))
	          && p->ser_number == what->ser_number))
	    ||
	   (what->flag& HK_FD && s_pipe[p->cmd.sp].fd ==
	    s_pipe[what->cmd.sp].fd && p->ser_number == what->ser_number))))
	{			/* replace already existing entry, dont want duplicate patterns */

#if DEBUG
	  fprintf (stderr, "replacing s_nr:%d , pattern:%s\n",
		   p->ser_number, p->pattern);
#endif	    
	    hook_replace(p,what,0,proc);
	    return;
	}
      else
	p = p->next;
  #ifdef _GUILE
  if (what->flag & HK_SCM){
     assert(gh_procedure_p(*((SCM *)proc)));
     what->cmd.scm=define_func(*((SCM *)proc));
     if(what->cmd.scm<0) error(-2,"malloc error");
  }
  #endif
  q=want[i].start;
  if (want[i].start != want[i].end
      && !(what->flag & HK_FD && want[i].start->flag&HK_FD &&
	  what->flag & HK_EXCLUSIVE))
    {
      p = want[i].end;
      if(what->ser_number==0)
        while(q!=p && q->ser_number!=0) q=q->next;
      else{
         p->ser_number=what->ser_number;
         while(q->ser_number < what->ser_number) q=q->next;
      }
     }
     insert_hook(q,what,&want[i].end);
     
}


static int add_numeric (pNumHook *, int);
void 
add_numhook2 (int numeric, On * what, void *proc)
{
  NumHook *N;
  On *p, *q;

  #ifdef _GUILE
  assert(what->flag&(HK_IN |HK_SCM | HK_FD));
  #else
  assert(what->flag&(HK_IN | HK_FD));
  #endif

  N = find_numhook (numeric);
  if (!N)
    {
      add_numeric (&numTree, numeric);
      N = find_numhook (numeric);
      assert (N);
    }
  what->flag &= ~HK_ISACTIVE;
  p = N->start;
  while (p != N->end)
    {
      if(!strcasecmp (p->pattern, what->pattern) &&
      (((p->flag & HK_PREEMPTIVE && what->flag&HK_PREEMPTIVE)
	   || (!(p->flag & HK_PREEMPTIVE) && !(what->flag&HK_PREEMPTIVE)))
	 &&
	 (((p->flag & (HK_IN | HK_SCM) && what->flag & (HK_IN | HK_SCM))
	 &&
	      ((what->flag & (HK_IN | HK_SCM))
	          && p->ser_number == what->ser_number))
	    ||
	   (what->flag& HK_FD && s_pipe[p->cmd.sp].fd ==
	    s_pipe[what->cmd.sp].fd && p->ser_number == what->ser_number))))

	{
	  hook_replace(p,what,0,proc);
	  return;
	}
      else
	p = p->next;
    }
  #ifdef _GUILE
  if (what->flag&HK_SCM){
  assert(gh_procedure_p(*((SCM *)proc)));
  what->cmd.scm=define_func(*((SCM *)proc));
  if(what->cmd.scm<0) error(-2,"malloc error");
  }
  #endif
  q = N->start;
  if ( N->start != N->end &&
       !(what->flag& HK_FD && !(N->start->flag & HK_EXCLUSIVE)))
    {
      p = N->end;
      if(what->ser_number==0)
        while(q!=p && q->ser_number!=0) q=q->next;
      else{
         p->ser_number=what->ser_number;
         while(q->ser_number < what->ser_number) q=q->next;
      }
     }
     insert_hook(q,what, &N->end);
}

NumHook *find_numhook (int numeric)
{
  NumHook *p = numTree;

  while (p)
    {
      if (p->numeric == numeric)
	return p;
      else if (p->numeric > numeric)
	p = p->left;
      else
	p = p->right;
    }
  return NULL;
}

static void 
num_left_rotate (pNumHook * pp)
{
  pNumHook p = *pp, r;
  *pp = r = p->right;
  p->right = r->left;
  r->left = p;
  p->bf--;
  if (r->bf > 0)
    p->bf -= r->bf;
  r->bf--;
  if (p->bf < 0)
    r->bf += p->bf;
}

static void 
num_right_rotate (pNumHook * pp)
{
  pNumHook p = *pp, l;
  *pp = l = p->left;
  p->left = l->right;
  l->right = p;
  p->bf++;
  if (l->bf < 0)
    p->bf -= l->bf;
  l->bf++;
  if (p->bf > 0)
    l->bf += p->bf;
}

static int 
add_numeric (pNumHook * pp, int numeric)
{

  int dH = 0;
  pNumHook p = *pp;


  if (p == NULL)
    {

      *pp = p = (pNumHook) malloc (sizeof (NumHook));
      if (!p)
	  error(-2,"malloc error");
      p->numeric = numeric;
      p->start = p->end = (On *) malloc (sizeof (On));
      if (!p->start)
	  error(-2,"malloc error");
      p->bf = 0;
      p->left = p->right = NULL;
      dH = 1;
    }
  else
    {
      if (numeric > p->numeric)
	{
	  if (add_numeric (&p->right, numeric))
	    {
	      p->bf++;
	      if (p->bf == 1)
		dH = 1;
	      else if (p->bf == 2)
		{
		  if (p->right->bf == -1)
		    num_right_rotate (&p->right);
		  num_left_rotate (pp);
		}
	    }
	}
      else if (numeric < p->numeric)
	{
	  if (add_numeric (&p->left, numeric))
	    {
	      p->bf--;
	      if (p->bf == -1)
		dH = 1;
	      else if (p->bf == -2)
		{
		  if (p->left->bf == 1)
		    num_left_rotate (&p->left);
		  num_right_rotate (pp);
		}
	    }
	}
      else
	{			/* numeric already in the list */

	}

    }
  return dH;
}
int 
do_internal_hook (On * h, const char *msg, int w, char preempt)
/* return 0 if processing should continue, else 1 */
{
  assert (h->flag& (HK_IN | HK_SCM));
#if defined _GUILE
  if (h->flag & HK_SCM)
    {
     
     #define DAT_SIZE 128
    char data[DAT_SIZE+1];
    Scm_cmd_arg args;
    SCM ret;
    
    if(snprintf(data,DAT_SIZE,"While processing hook %d, SN=%d: \"%s\"",
      h->flag, h->ser_number,(char *)msg)==-1)
       {data[DAT_SIZE]=0;
	strcpy(&data[DAT_SIZE-4],"...\"");
       }
     args.func=h->cmd.scm;
     args.args=gh_list(gh_str02scm ((char *) msg),
		                gh_long2scm(w),
				SCM_UNDEFINED);
     ret=gh_catch(SCM_BOOL_T, &call_scm_command, &args,
		 (scm_catch_handler_t)&exception_handler, (void *)&data);
     if(preempt)
           return (!gh_equal_p(ret,SCM_BOOL_F)); //#f continues 
      else return 0;
    }
  else if(!preempt)
#endif
    {

#define BUFF	2048
      char *buf;
      char *ptr, *pp;
      int len;

      if (*(h->cmd.cmd)==':' && *(h->cmd.cmd+1)=='\0')
	return 0;
      len = BUFF + 1 + strlen (h->cmd.cmd);
      buf = alloca (sizeof (char) * (len));
      if (buf==NULL)
	  error(-2,"malloc error");
      ptr = buf;
      pp = h->cmd.cmd + find_pos ((char *) h->cmd.cmd, 2);
      while (*pp && (*ptr = *pp++) && (ptr - buf) < len)
	{
	  if (*ptr == '\\' && *pp == '$')
	    {
	      *ptr = '$';
	      pp++;
	    }
	  else if (*ptr == '$' && isdigit (*pp))
	    {
	      u_short pos;
	      char *p;
	      if (sscanf (pp, "%hu", &pos) < 0)
		continue;
	      else
		{
		  char t[10];

		  sprintf (t, "%hu", pos);
		  pp += strlen (t);
		  if (*pp == '-' || pos == 0)
		    {
		      int n;
		      if (*pp == '-')
			pp++;
		      n = pos ? find_pos ((char *) msg, pos) : 0;
		      if (n < 0)
			continue;
		      p = (char *) msg + n;
		      while (*p)
			*ptr++ = *p++;
		    }
		  else
		    {
		      p = nextstr (msg, pos);	/* $1=>1st word */
		      if (*p){
			char *p2=(char *)p;
			while (*p2)
			  *ptr++ = *p2++;
		      }
		      free(p);
		    }
		  continue;
		}
	    }
	  ptr++;
	}
      *ptr = '\0';
      {
	char *cmd;
	char *buffer;

	cmd = nextstr (h->cmd.cmd, 1);
	buffer = malloc (sizeof (char) * (strlen (buf) + 3 + strlen (cmd)));
	if (!buffer)
	    error(-2,"Malloc error");
	sprintf (buffer, "%s %s", *cmd == cmdchar ? cmd + 1 : cmd, buf);
	free(cmd);
	/*fputs(buffer,stderr);*/
	new_process_cmd (buffer, w);
	free (buffer);
      }
    }
    return 0;
}
#ifdef _GUILE
static int check_preemptive(int i,int w,char *buf){
On *p;
char *m=lowercase(buf);
int ret=0;

p = want[i].start;
  while (p != want[i].end)
    {
      if (!(p->flag & HK_SUSPENDED) && (p->flag&HK_SCM) && (p->flag&HK_PREEMPTIVE))
      if (!fnmatch (p->pattern, m, FNM_PATHNAME | FNM_PERIOD) )
	{
	      p->flag |= HK_ISACTIVE;
	      ret=do_internal_hook (p, buf, w,1);
	      p->flag &= ~HK_ISACTIVE;
	      if(ret) break;
	}
      p = p->next;
    }
  free(m);
  return ret;
  }
static int check_preemptive_numeric(NumHook *N,int w,char *buf0){
On *p;
char *m;
int ret=0;

p = N->start;
  m= lowercase (buf0);
  while (p != N->end)
    {
      if (!(p->flag & HK_SUSPENDED) && (p->flag&HK_SCM) && (p->flag&HK_PREEMPTIVE))
      if (!fnmatch (p->pattern, m, FNM_PATHNAME | FNM_PERIOD) )
	{
	      
	      p->flag |= HK_ISACTIVE;
	      ret=do_internal_hook (p, buf0, w,1);
	      p->flag &= ~HK_ISACTIVE;
	      if(ret) break;
	}
      p = p->next;
    }
  free(m);
  return ret;
  }
#endif
extern int 
check_msg_hook (MsgNr type,int w, const char *fmt,...)
{
  register  i;

  i = get_type_by_num(type);
  if(i<0 || want[i].start == want[i].end) return 0;
else{
  	On *p;
  	char  *m, stop = 0, do_external = 1;
	va_list ap;
	#define BSIZE 2048
	char buf[BSIZE];

        va_start(ap, fmt);
        if(vsnprintf(buf,BSIZE, fmt, ap)==-1)
	   buf[BSIZE-1]=0;
        va_end(ap);
  /* buf:= <win> <id> <server,port> <msg> */
  if(buf[0]==0) buf[0]=' ';
  #ifdef _GUILE
  if(check_preemptive(i,w,buf)) return 1;
  #endif
  m=lowercase (buf);
  p = want[i].start;
  while (p != want[i].end)
    {
      if (!(p->flag & HK_SUSPENDED)
      #ifdef _GUILE
        && !(p->flag &HK_PREEMPTIVE)
      #endif
      ){
      if (!fnmatch (p->pattern, m, FNM_PATHNAME | FNM_PERIOD) )
	{
	  if (p->flag & HK_FD)
	    {
	      if (do_external)
		{
		  char *s=alloca(sizeof(char)*(strlen(buf)+64));
		  sprintf (s, "%d %d %s\n", w, p->ser_number,buf);
		  if (!write_to_sp (p->cmd.sp,s) &&
		      (p->flag & HK_EXCLUSIVE))
		    do_external = 0;
		}
	    }
	  else if (p->flag & (HK_SCM | HK_IN) /*&& !stop <-- wrong */ )
	    {
	      /* stop after first match if ser_number==0 */
	      p->flag |= HK_ISACTIVE;
	      do_internal_hook (p, buf, w,0);
	      p->flag &= ~HK_ISACTIVE;
	      if (p->ser_number == 0)
		stop = 1;
	    }
	}
      }
      p = p->next;
    }
  free (m);
  return (stop || !do_external);
  }
}

extern int 
check_numeric (int numeric,Winstruct *win, const char *msg)
{
  NumHook *N;

  N = find_numhook (numeric);
  if (!N || N->start == N->end)
    return 0;
  else{
  On *p;
  char *buf0, *m, stop = 0, do_external = 1;
  int w=win-winstruct;

  if(gflags&MATCH_SERVER_ALIAS){
  buf0= alloca(sizeof(char)*(strlen(msg)+ strlen(win->server->servname)+12));
  sprintf(buf0,"%s,%hu %s", win->server->servname, win->server->port, msg);
  }else{
  buf0= alloca(sizeof(char)*(strlen(msg)+ strlen(win->server->name)+12));
  sprintf(buf0,"%s,%hu %s", win->server->name, win->server->port, msg);
  }
  #ifdef _GUILE
  if(check_preemptive_numeric(N,w,buf0)) return 1;
  #endif
  p = N->start;
  m= lowercase (buf0);
  while (p != N->end)
    {
      if(!(p->flag & HK_SUSPENDED)
      #ifdef _GUILE
        && !(p->flag &HK_PREEMPTIVE)
      #endif
      ){
      if (fnmatch (p->pattern, m, FNM_PATHNAME | FNM_PERIOD)==0)
	{
	  if (p->flag&HK_FD)
	    {
	      if (do_external)
		{
		  char buf[1048];
		  /* <win> <id> <server,port> <msg> */
		  sprintf (buf, "%d %d %s,%hu %s\n", w, p->ser_number,
			   gflags&MATCH_SERVER_ALIAS?win->server->servname:
			   win->server->name,
			   win->server->port, msg);
		  if (!write_to_sp (p->cmd.sp, buf) &&
		      (p->flag & HK_EXCLUSIVE))
		    do_external = 0;
		}
	    }
	  else if (p->flag &(HK_SCM | HK_IN))
	    {
	      p->flag |= HK_ISACTIVE;
	      do_internal_hook (p, buf0, w,0);
	      p->flag &= ~HK_ISACTIVE;
	      if (p->ser_number == 0)
		stop = 1;
	    }
	}
      }
      p = p->next;
    }
  free (m);
  return (stop || !do_external);
 }
}

static int 
remove_hook (MsgNr type, char *str, int num,char preempt)
{
/*  
   remove one or many events for a message type or for a numeric(if
   numeric!=0)

   #privmsg 300 "foo bar base.." 
   quotes not required if either a ser_no is given, or '#' is not used.
   1)
   -del #type [ser_no] [pattern]
   ser_no not given => remove all serial nos (ser_no=-1)
   2)
   -del type [pattern]
   => ser_no=0
   pattern not given at all => all patterns

 */
  char *pattern;
  int ser_nr = -1;
  char *s;

  pattern = alloca (sizeof (char) * strlen (str));
  *pattern = '\0';
  if (*str == '#')
    {
      if (*(str + 1) == '\0')
	return -2;
      s=nextstr (str, 2);
      if (sscanf (str, "%*s %d", &ser_nr) < 1 && *s)
	{
	  fprintf (stderr, "error:missing ser_no for \"#\"\n");
	  free(s);return -2;
	}
      sscanf (str, "%*s %*s %[^\n]\n", pattern);
      free(s);
    }
  else
    {
      ser_nr = 0;
      sscanf (str, "%*s %[^\n]\n", pattern);
    }
  if (*pattern && *pattern == '"')
    {
      size_t ll = strlen (pattern) - 1;
      if (ll > 0 && *(pattern + ll) == '"')
	{
	  *(pattern + ll) = '\0';
	  s = pattern + 1;
	}
      else
	{
	  fprintf (stderr, "unterminated \"\"\"\n");
	  return -3;
	}
    }
  else
    s = *pattern ? pattern : NULL;
  if (num)
    remove_numhook_bynum (num, ser_nr, s, numTree,preempt);
  else
    remove_hook_bytype (type, ser_nr, s,preempt);
  if (script_form)
    list_hooks (1);
  return 0;
}
void 
delete_hook (char *what,char preempt)
{
  int had_error = 1, num;
  char *cmd, *tt, *foo;

  foo = alloca (sizeof (char) * (1 + strlen (what)));
  sscanf (what, "%s", foo);
  cmd=foo;
  if (*cmd == '#'){
    cmd++;
    if ((*cmd == '\0'))
    {
      fprintf (stderr, "%s: missing comand type or numeric", what);
      return;
     }
  }
  num = strtol (cmd, &tt, 0);
  if (*tt)
    {
      MsgNr type = get_type (cmd);
      if (type != INVALID)
	had_error = remove_hook (type, what, 0,preempt);
      else
	fprintf (stderr, "Unknown message type:%s\n", cmd);
    }
  else if (!(*tt) && num > 0)
    had_error = remove_hook (0, what, num,preempt);
  else
    fprintf (stderr, "Invalid numeric:%s\n", cmd);
  if (!had_error && script_form)
    list_hooks (1);

}
#if 0
void 
list_on (FL_OBJECT * brow)
{
  static void list_num_on (NumHook * h, FL_OBJECT * brow);
  int i;
   On *p;
  char *buf;
  #define LLEN 513
  buf = alloca (sizeof (char) * LLEN);
      
      sprintf (buf, "@N@m%-14.18s ID  %-10s Sock %s ", "Command", "SN", "Pattern");
      fl_addto_browser (brow, buf);
      for (i=0; i<MAX_ON; i++)
	{
	  p = want[i].start;
	  while (p != want[i].end)
	    {
	      *buf = 0;
	      
	      if(snprintf (buf,LLEN, "%s%-19.17s %-5d %-12d %-6d %s", (
		p->flag & HK_SUSPENDED ||  (p->flag & HK_FD  &&
		    s_pipe[p->cmd.sp].status & (SCR_SUSPENDED | SCR_STOPPED))
		       )? "@C4@z" : "",
		       msg_type[i].name,
		       p->id, p->ser_number,
		       (p->flag & HK_FD) ? p->cmd.sp : (-1),
		       p->pattern)==-1)
		 buf[LLEN]=0;
	      fl_addto_browser (brow, buf);
	      p = p->next;
	    }
	}
      list_num_on (numTree, brow);
}
static void 
list_num_on (NumHook * h, FL_OBJECT * brow)
{
  if (h)
    {
      On *p;
      char *buf;
      list_num_on (h->left, brow);
      buf = malloc (sizeof (char) * LLEN);
      p = h->start;
      while (p != h->end)
	{
	  if(snprintf (buf,LLEN,
		   "%s%-19.3d %-5d %-12d %-6d %s",
		   (p->flag & HK_SUSPENDED ||
		    (p->flag & HK_FD &&
		     s_pipe[p->cmd.sp].status & (SCR_SUSPENDED | SCR_STOPPED)
		    )
		   )? "@C4@z" : "",
		   h->numeric,
		   p->id, p->ser_number,
		   (p->flag & HK_FD) ? p->cmd.sp : (-1),
		   p->pattern)==-1)
	   buf[LLEN]=0;
	  fl_addto_browser (brow, buf);
	  p = p->next;
	}
      free (buf);
      list_num_on(h->right, brow);
    }
}

#endif

