
/****************************************************************/
/*								*/	
/*		M O D E						*/
/*								*/
/****************************************************************/


/* mode.c	-mode changes  from server

    distributed as part of _sula_.
    Author: Tano Fotang, 1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License , or
    (at your option) any later version.

    see the file sula/COPYING for more information.

*/

#include <forms.h>
#include <errno.h>
#include <ctype.h>
#include "aux.h"
#include "sula.h"
#include "chanwin.h"
#include "global.h"
#include "script.h"
#include "parser.h"
#include "mode.h"
#include "setting.h"
#include "ignore.h"
#include "scheme.h"
#include "hooks.h"

extern void  p_mode(void){
	char *changed=NULL, *changer=NULL, *mode=NULL, *buf=NULL;
	size_t ll;
	int to;

	ll=strlen(Msg);
	changer=(char *)alloca(sizeof(char)*ll);
	changed=(char *)alloca(sizeof(char)*ll);
	mode=(char *)alloca(sizeof(char)*ll);
	if(sscanf(Msg, "%s MODE %s %s", changer,changed, mode)<3)
		return;
	to= Win-winstruct;
	if(*changed!='#' && *changed!='&'){
		char *pmode=mode;
		if(*pmode==':') pmode++;
		if(!ignored(changer, IG_MISC) &&
		 !check_msg_hook(MODE, Win-winstruct,"%s,%d %s",
		 Win->server->servname,Win->server->port,Msg))
		if(gflags&SHOW_RAW_MSG) say(Msg,to,1);
		else{
			fmt_string="%f%n%p$";
			buf=format_msg(fmt_usermode,changer, changed, pmode);
		  	if(buf){
			       say(buf, to,1);
			       free(buf);
			       }
		}
		if(!strcasecmp(changed,Win->server->nick))
  			changemymode(Win, pmode, 0);
	}
	 else	{
		sscanf(Msg, "%*s MODE %*s %[^\n]\n", mode);
		if(!ignored(changer, IG_MISC) && 
		!check_msg_hook(MODE, Win-winstruct,"%s,%d %s",
		 Win->server->servname,Win->server->port,Msg))
		if(gflags&SHOW_RAW_MSG)  say(Msg,to,1);
		else{
			char *nick, *login, *host;
			int i;
			size_t ll=strlen(changer);
			nick=(char *)alloca(sizeof(char)*ll);
			login=(char *)alloca(sizeof(char)*(ll+10));
			host=(char *)alloca(sizeof(char)*(ll+10));
			i=sscanf(Msg, "%[^!]!%[^@]@%s", nick,login,host);
			if(i==1){
			strcpy(login,"#unknown");strcpy(host,"#unknown#");
			}
			else if(i==2){ strcpy(host,"#unknown#");} 
			if(*login=='~') strshift(login,1);
			fmt_string="%n%l%h%p%c$";
			buf=format_msg( fmt_chanmode, nick, login,host,mode, changed);
		 	if(buf){
	 		 	say(buf,to,1);
				free(buf);
				}
	    	}
		if(
	 		changechanmode(Win, changed, mode, 0) && 
	 		!strcasecmp(changed, Win->chanCur->name)
			)
	 	 		update_server_stuff(Win->server->fd);
		}
}

extern void changemymode(Winstruct *win, char *mode, int reset){
/* change your server    mode 
*	reset>0: clear mode and set new mode
*/
	if(!mode) return;
	if(reset && Win->server->mode){/* free( Win->server->mode );*/
			Win->server->mode=NULL;}
	while(*mode){
 	   if(*mode=='+')
 		 while(*++mode && *mode!='-')
 		     addmode(&Win->server->mode,*mode);
 	   if(*mode=='-')
 		 while(*++mode && *mode!='+')
		     Win->server->mode=strdchr(Win->server->mode,*mode);
 	}
	
 	if(!(Win->server->mode) || !(*Win->server->mode)) Win->server->mode=NULL;
 	update_server_stuff(Win->server->fd);

}
extern int changechanmode(Winstruct *win, const char *channame, char *mode, int reset){
/* change channel modes 
   reset!=0: clear modes and update, this should be a response to
	RPL_CHANNELMODEIS. see numeric.c
*/	 
	 Channel *chan;
	 char update=0;	/* update display after this */
	 char usermode=0;
	 static void change_gokey(Winstruct *, const char *, const char *);
	 if(!mode) return 0; 
	 chan = get_chan_byname(win, channame);
	 if(chan==NULL) return 0;
	 if(reset && chan->modes ){
	   	/* RPL_CHANNELMODEIS doesnt supply the o and v modes, so save them
		first before clearing channel modes
		*/
	 	char t[3]/*=(char*)malloc(sizeof(char)*3)*/, *p=t;
		
	 	if(strchr(chan->modes, 'o')) *p++='o';
		if(strchr(chan->modes, 'v')) *p++='v';
		*p='\0';
		if(t[0]) chan->modes=strdup(t);
		else{ chan->modes=NULL;}
	 }
	 while(*mode){
		if(*mode=='+'){
			while(*++mode && *mode!='-' ){
			     if(!isgraph(*mode)) continue; /* skip space and ctrl-chars*/
			     switch(*mode){
			       case 'l':{
			       		char *l=nextstr(mode,2);
					if(*l==0) break;
					chan->limit=atoi(l);
					rmstr(mode,1);
					break;
					}
			       case 'k':{
					chan->key=nextstr(mode,2);
			       		if(*(chan->key)==0) break;
			       		change_gokey(win, channame, chan->key);
					rmstr(mode,1); break;
				       }
				case 'b': /* someone's been banned*/
					rmstr(mode,1);
					break;
				case '+': break;
				case 'o':
				case 'v':{
					char *nick=nextstr(mode,2);
					if(*nick==0) break;
					usermode=1;
					rmstr(mode,1);
					if( !strcasecmp(win->server->nick, nick)){
						/* our mode has been changed */
					       addmode(&chan->modes,*mode);
					       update=1;
					}
					free(nick);
					break;
					}
			       default: addmode(&chan->modes,*mode);break;
			      }
			}
		}/* if(*mode=='+') */

		if(*mode && *mode=='-'){
			 while(*++mode && *mode!='+'){
			     if(!isgraph(*mode)) {continue;}
			     switch(*mode){
				case 'l':chan->limit=0;break;
				case 'k': 
				 	chan->key=NULL; rmstr(mode,1);
					change_gokey(win, channame, NULL);
					break;
				case 'b': /* someone's been unbanned*/
					rmstr(mode,1);
					break;
				case '-': break;
				case 'o':
				case 'v':{
					char *nick=nextstr(mode,2);
					if(*nick==0) break;
					usermode=1;
					rmstr(mode,1);
					if( !strcasecmp(win->server->nick, nick)){
						/* our channel mode has been changed*/
					       chan->modes=strdchr(chan->modes,*mode);
					       update=1;
					}
					free(nick);
					break;
					}
				 default: chan->modes=strdchr(chan->modes,*mode); 
				 	break;
			    }
			 }
		}
		else if(*mode && *mode!='+') mode++;
	}/*while(*mode)*/
	 if(!chan->modes || !(*chan->modes)) chan->modes=NULL;
	 if(usermode && !update) return 0;
	 return 1;
}
#if 0
static void remove_gokey(Winstruct *win, const char *chan){
	Go *p=win->goStart;
	while(p!=win->goEnd)
		if(!strcasecmp(p->name, chan)){
			free(p->key); p->key=NULL;
			break;
		}else
		p=p->next;
}
#endif
static void change_gokey(Winstruct *win, const char *chan, const char *key){
	Go *p=win->goStart;
	while(p!=win->goEnd)
		if(!strcasecmp(p->name, chan)){
			free(p->key);
			if(key)
				p->key=strdup(key);
			else
				 p->key=NULL;
			break;
		}else
		p=p->next;
}


extern void addmode(char **s, char c){
	size_t ll=0;
	if(!(*s)) *s=(char *)malloc(sizeof(char)*2);
	else{	if( strchr(*s, c) ) return;
		ll=strlen(*s);
		 *s=realloc(*s, (ll+1)*sizeof(char) );
		 /*		^^^^^|-> sizeof(*s)+1	*/
	}
	*(*s+ ll++)=c;
	*(*s+ll)='\0';
}

extern void update_server_stuff(int fd){
	

	if(fd<0) return;
	else{
	WinList *p;
	build_winlistbyfd(fd);
	p=servWin;
	while( p){
	   UpdateStatus(p->win);
	   p=p->next;
	}
	}
}


